/*!
\file    djstring.h
\brief   Some string helper functions
\author  David Joffe
*/
/*--------------------------------------------------------------------------*/
#ifndef _DJSTRING_H_
#define _DJSTRING_H_

//! Make a deep copy of string. Must be deleted with "delete".
extern char * djStrDeepCopy( const char * src );
extern char * djStrDeepCopy( const char * src, int n );

//! Convert string in-place to uppercase
extern void   djStrToLower( char * str );

//! For returning sections of strings using given delimiters. i is 1-based
//! eg djStrPart("a,b;c,d", 3, ",;") should return "c"
//! You are responsible for deleting the string it returns
extern char * djStrPart( char * str, int i, char * delim );

#endif
