
#include "inventory.h"
#include "mission.h"
#include "graph.h"

#include "thing.h"

#include <vector>
using namespace std;
vector<CThing *> g_apInventory;


// X,Y location on screen to draw inventory (in pixels)
#define INVENTORY_X (28*8)
#define INVENTORY_Y (17*8)


void InvClear()
{
	for ( int i=0; i<(int)g_apInventory.size(); i++ )
	{
		if (g_apInventory[i]->OnInventoryClear())
		{
			DEL(g_apInventory[i]);
			g_apInventory.erase(g_apInventory.begin() + i);
			i--;
		}
	}
}

void InvEmpty()
{
	for ( int i=0; i<(int)g_apInventory.size(); i++ )
	{
		DEL(g_apInventory[i]);
	}
	g_apInventory.clear();
}

bool InvAdd(CThing *pThing)
{
	if (g_apInventory.size()>=INV_MAXSIZE)
		return false;
	g_apInventory.push_back(pThing);
	InvDraw(); // redraw
	return true;
}

void InvDraw()
{
	for ( int i=0; i<5; i++)
	{
		// Background blocks
		DRAW_SPRITE16(pVisBack, 0, 1, INVENTORY_X + i*16, INVENTORY_Y);
		DRAW_SPRITE16(pVisBack, 0, 1, INVENTORY_X + i*16, INVENTORY_Y+16);
		// Inventory items 0-4
		if (i<(int)g_apInventory.size())
		{
			CThing *pThing = g_apInventory[i];
			DRAW_SPRITE16A(pVisBack, pThing->m_a, pThing->m_b, INVENTORY_X + i*16, INVENTORY_Y);
		}
		// Inventory items 5-9
		if (i+5<(int)g_apInventory.size())
		{
			CThing *pThing = g_apInventory[i+5];
			DRAW_SPRITE16A(pVisBack, pThing->m_a, pThing->m_b, INVENTORY_X + i*16, INVENTORY_Y+16);
		}
	}
}

int InvGetSize()
{
	return g_apInventory.size();
}

CThing *InvGetItem(int n)
{
	return g_apInventory[n];
}

void InvRemove(CThing *pThing)
{
	for ( int i=0; i<(int)g_apInventory.size(); i++ )
	{
		if (pThing==g_apInventory[i])
		{
			g_apInventory.erase(g_apInventory.begin() + i);
			InvDraw();
			return;
		}
	}
}

